'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.useModel = useModel;
exports.useOn = useOn;
exports.useEmit = useEmit;
exports.useQueryIds = useQueryIds;
exports.useLocalDoc = useLocalDoc;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _model = require('@react-sharedb/model');

var _model2 = _interopRequireDefault(_model);

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var boundEmit = _model2.default.emit.bind(_model2.default);

function useModel() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return (0, _react.useMemo)(function () {
    return _model2.default.scope.apply(_model2.default, args);
  }, [].concat(args));
}

function useOn() {
  for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  (0, _react.useLayoutEffect)(function () {
    var eventName = args[0];

    var listener = _model2.default.on.apply(_model2.default, args);
    return function () {
      _model2.default.removeListener(eventName, listener);
    };
  });
}

function useEmit() {
  return boundEmit;
}

function useQueryIds(collection) {
  var ids = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var _useQuery = (0, _types.useQuery)(collection, { _id: { $in: ids } }),
      _useQuery2 = (0, _slicedToArray3.default)(_useQuery, 3),
      $items = _useQuery2[1],
      ready = _useQuery2[2];

  if (!ready) return [undefined, $items, ready];
  var items = ids.map(function (id) {
    return _model2.default.get(collection + '.' + id);
  }).filter(Boolean);
  return [items, $items, ready];
}

function useLocalDoc(collection, docId) {
  if (typeof collection !== 'string') {
    throw new Error('[react-sharedb] useLocalDoc(): `collection` must be a String. Got: ' + collection);
  }
  if (!docId) {
    console.warn('\n      [react-sharedb] useLocalDoc(): You are trying to subscribe to an undefined document id:\n        ' + collection + '.' + docId + '\n      Falling back to \'__NULL__\' document to prevent critical crash.\n      You should prevent situations when the `docId` is undefined.  \n    ');
    docId = '__NULL__';
  }
  return (0, _types.useLocal)(collection + '.' + docId);
}